/*
 * Broadcast.java
 *
 * Created on September 9, 2011, 1:40 PM
 */
package audiovideo;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.Deflater;
import javax.sound.sampled.*;
import javax.swing.JOptionPane;

/**
 *
 * @author  user
 */
public class Broadcast extends javax.swing.JFrame {

    String user;
    String meeting;
    final AudioFormat format = getFormat();
    int soundPacket = 1;
    public static boolean lineStarted = false;
    public static byte[] gsmBuf;

    /** Creates new form Broadcast */
    public Broadcast(String _user, String _meeting) {
        initComponents();
        screen = panScreen;
        user = _user;
        meeting = _meeting;

        // Defaulft values
        Framework.hasTheFloor = true;
        Framework.hasMicrophone = true;
        Framework.hasWebcam = true;

        // Start audio capture annd streaming
        try {
            captureAndStream();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void captureAndStream() throws LineUnavailableException {
        // ******************************
        // AUDIO CAPTURE AND STREAMING **
        // ******************************
        // ******************************
        System.out.println("AUDIO CAPTURE AND STREAMING");
        if (Framework.hasMicrophone && Framework.hasTheFloor) {
            Runnable runner = new Runnable() {

                int bufferSize = (int) (format.getSampleRate() * format.getFrameSize() / 1);
                byte buffer[] = new byte[bufferSize];

                public void run() {
                    try {
                        if (!lineStarted) {
                            lineStarted = true;

                            System.out.println("Audio capture initialization");
                            DataLine.Info info = new DataLine.Info(
                                    TargetDataLine.class, format);
                            final TargetDataLine line = (TargetDataLine) AudioSystem.getLine(info);
                            line.open(format);
                            line.start();

                            System.out.println("Capture and streaming started");
                            int i = 0;
                            while (true) {
                                int count = line.read(buffer, 0, buffer.length);
//                            int count = gsmAIS.read(buffer, 0, bufferSize);
                                if (count > 0) {
                                    if (Framework.hasMicrophone) {
//                                    byte[] gsmBuf = compressAudio(buffer); //

                                        gsmBuf = zipAudio(buffer); //

                                        // Send accross the network using HTTP
                                        System.out.println("Size packet sent : " + gsmBuf.length);
//                                    ReceptionStream.decompressAudio(gsmBuf);

                                        HttpBinaryTransfer.sendPacket(gsmBuf,
                                                Framework.servletURL,
                                                "audio",
                                                user,
                                                meeting,
                                                soundPacket++);

//                                    System.out.println("Packet sentII, size " + gsmBuf.length);
                                    }
                                }
                                i++;
                            }
//                    out.close();
                        } else { /// THE LINE IS ALREADY STARTED, JUST SEND PACKETS
                            while (true) {
                                if (Framework.hasMicrophone) {
                                    System.out.println("Size packet sent 2 : " + gsmBuf.length);

                                    HttpBinaryTransfer.sendPacket(gsmBuf,
                                            Framework.servletURL,
                                            "audio",
                                            user,
                                            meeting,
                                            soundPacket++);
                                    
                                    Thread.sleep(1000);
                                }
                            }
                        }
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }
            };
            Thread captureThread = new Thread(runner);
            captureThread.start();
        }
    }

    static public AudioFormat getFormat() {
        float sampleRate = 8000;
        int sampleSizeInBits = 8;
        int channels = 1;
        boolean signed = true;
        boolean bigEndian = true;
        return new AudioFormat(sampleRate,
                sampleSizeInBits, channels, signed, bigEndian);
    }

    static public void writeIntoFile(byte[] buf, File file) throws FileNotFoundException, IOException {
        DataOutputStream dos = new DataOutputStream(new FileOutputStream(file));
        dos.write(buf);
        dos.close();
    }

    static public byte[] readFromFile(File file) throws FileNotFoundException, IOException {
        FileInputStream fileinputstream = new FileInputStream(file);

        int numberBytes = fileinputstream.available();
        byte bytearray[] = new byte[numberBytes];

        fileinputstream.read(bytearray);
        return bytearray;
    }

    static private byte[] compressAudio(byte[] sndBuffer) throws Exception {
//        File file = new File("soundPacketSent.v");
//        writeIntoFile(sndBuffer, file);
//        JSpeexEnc.main(new String[]{"--rate", "8000" , "--quiet", "soundPacketSent.v", "soundPacketSent.spx"});
//        
//        byte[] compressedBuf = readFromFile(new File("soundPacketSent.spx"));
////        System.out.println("Packet sent "+compressedBuf.length);
//        return compressedBuf;
//        JSpeexDec.main(new String[]{"soundPacket.spx", "soundPacket2.v


        ByteArrayInputStream bis = new ByteArrayInputStream(sndBuffer);
        ByteArrayOutputStream bos = new ByteArrayOutputStream();

        AudioInputStream ais = new AudioInputStream(bis, getFormat(), sndBuffer.length);

//        AudioFormat.Encoding targetEncoding = new AudioFormat.Encoding("GSM0610");
//        AudioFormat.Encoding targetEncoding = AudioFormat.Encoding.ULAW;
        AudioFormat.Encoding targetEncoding = new AudioFormat.Encoding("MPEG1L3");

        final AudioInputStream gsmAIS = AudioSystem.getAudioInputStream(targetEncoding, ais);
//        final AudioInputStream gsmAIS;// = Mp3Encoder.getConvertedStream(ais, targetEncoding);
        ByteArrayOutputStream gsmBAOS = new ByteArrayOutputStream();
//        AudioFileFormat.Type gsmFileType = new AudioFileFormat.Type("GSM", ".gsm");
        AudioFileFormat.Type gsmFileType = new AudioFileFormat.Type("MP3", ".mp3");
//        final AudioInputStream gsmAIS ;
        AudioSystem.write(gsmAIS, gsmFileType, gsmBAOS);

//        System.out.println("Frame rate " + gsmAIS.getFormat().getFrameRate()+ " Frame size "+
//                gsmAIS.getFormat().getFrameSize()+ " Sample Rate "+gsmAIS.getFormat().getSampleRate()
//                + " Sample Size in Bits"+gsmAIS.getFormat().getSampleSizeInBits()+ "  "+
//                gsmAIS.getFormat().isBigEndian());
//        System.out.println("GSM Encoding format" + gsmAIS.getFormat());

//        System.out.println("MP3 FORMAT : "+gsmAIS.getFormat().getFrameRate());

//        System.out.println("bytes/frame = "+gsmAIS.getFormat().getFrameSize());
//        System.out.println("frames/second = "+gsmAIS.getFormat().getFrameRate());

//        byte[] zipBuff = new byte[sndBuffer.length];
//        
//        int numBytes = 1;
//        while(true){
//            numBytes = gsmAIS.read(zipBuff, 0, zipBuff.length);
//            if (numBytes<=0) break;
//            bos.write(zipBuff,0,numBytes);
//        }

        byte[] gsmBuff = gsmBAOS.toByteArray();

//        AudioInputStream normal = AudioSystem.getAudioInputStream(new ByteArrayInputStream(gsmBuff));
//        System.out.println(normal.getFormat());

//        byte [] gsmBuff = bos.toByteArray();

//        System.out.println("Packet size " + gsmBuff.length);

        return gsmBuff;
    }

    static private byte[] zipAudio(byte[] input) {

// Create the compressor with highest level of compression
        Deflater compressor = new Deflater();
        compressor.setLevel(Deflater.BEST_COMPRESSION);

// Give the compressor the data to compress
        compressor.setInput(input);
        compressor.finish();

// Create an expandable byte array to hold the compressed data.
// You cannot use an array that's the same size as the orginal because
// there is no guarantee that the compressed data will be smaller than
// the uncompressed data.
        ByteArrayOutputStream bos = new ByteArrayOutputStream(input.length);

// Compress the data
        byte[] buf = new byte[1024];
        while (!compressor.finished()) {
            int count = compressor.deflate(buf);
            bos.write(buf, 0, count);
        }
        try {
            bos.close();
        } catch (IOException e) {
        }

// Get the compressed data
        byte[] compressedData = bos.toByteArray();

        return compressedData;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lblTitle = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jPanel1 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        cmbMediaType = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        txtFrameRate = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        lblStatus = new javax.swing.JLabel();
        cmdSet = new javax.swing.JButton();
        cmdClose = new javax.swing.JButton();
        panScreen = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        lblTitle.setFont(new java.awt.Font("Tahoma", 0, 12));
        lblTitle.setText("Broadcasting. User name: xxxx, Meeting: xxx");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        jLabel3.setText("Media type");

        cmbMediaType.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Audio and Video", "Audio only", "Video only", "None" }));
        cmbMediaType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbMediaTypeActionPerformed(evt);
            }
        });

        jLabel4.setText("Video frame rate");

        txtFrameRate.setText("1");

        jLabel5.setText("Frame/Sec");

        jLabel6.setText("Status");

        lblStatus.setText(".");

        cmdSet.setText("SET");
        cmdSet.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdSetActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 25, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(txtFrameRate, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 5, Short.MAX_VALUE)
                        .addComponent(cmdSet))
                    .addComponent(cmbMediaType, 0, 193, Short.MAX_VALUE)
                    .addComponent(lblStatus, javax.swing.GroupLayout.DEFAULT_SIZE, 193, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(cmbMediaType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5)
                    .addComponent(txtFrameRate, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(cmdSet))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(lblStatus)))
        );

        cmdClose.setText("HIDE");
        cmdClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdCloseActionPerformed(evt);
            }
        });

        panScreen.setBackground(new java.awt.Color(0, 0, 0));
        panScreen.setMinimumSize(new java.awt.Dimension(320, 240));
        panScreen.setPreferredSize(new java.awt.Dimension(320, 240));

        javax.swing.GroupLayout panScreenLayout = new javax.swing.GroupLayout(panScreen);
        panScreen.setLayout(panScreenLayout);
        panScreenLayout.setHorizontalGroup(
            panScreenLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 320, Short.MAX_VALUE)
        );
        panScreenLayout.setVerticalGroup(
            panScreenLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 240, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblTitle)
                .addContainerGap(85, Short.MAX_VALUE))
            .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 340, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(panScreen, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(273, Short.MAX_VALUE)
                .addComponent(cmdClose)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblTitle)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(panScreen, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cmdClose)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void cmdCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdCloseActionPerformed
        // TODO add your handling code here:
        Framework.broadCastVisible = false;
        this.setVisible(false);
}//GEN-LAST:event_cmdCloseActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        // TODO add your handling code here:
        lblTitle.setText("Broadcasting. User name: " + user + ", Meeting: " + meeting);
    }//GEN-LAST:event_formWindowOpened

    private void cmbMediaTypeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbMediaTypeActionPerformed
        // TODO add your handling code here:
        if (cmbMediaType.getSelectedIndex() == 0) {
            Framework.hasMicrophone = true;
            Framework.hasWebcam = true;
        } else if (cmbMediaType.getSelectedIndex() == 1) {
            Framework.hasMicrophone = true;
            Framework.hasWebcam = false;
        } else if (cmbMediaType.getSelectedIndex() == 2) {
            Framework.hasMicrophone = false;
            Framework.hasWebcam = true;
        } else {
            Framework.hasMicrophone = false;
            Framework.hasWebcam = false;
        }
    }//GEN-LAST:event_cmbMediaTypeActionPerformed

    private void cmdSetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdSetActionPerformed
        // TODO add your handling code here:
        try {
            double rate = Double.parseDouble(txtFrameRate.getText());
            if (rate == 0) {
                throw new Exception();
            }
            Framework.IMAGE_DURATION = (long) Math.round((1 / rate) * 1000);
            JOptionPane.showMessageDialog(this, "Video frame rate updated !");
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, "Please enter a number > 0");
        }
    }//GEN-LAST:event_cmdSetActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        Framework.broadCastVisible = false;
        this.setVisible(false);
    }//GEN-LAST:event_formWindowClosing

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox cmbMediaType;
    private javax.swing.JButton cmdClose;
    private javax.swing.JButton cmdSet;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel lblStatus;
    private javax.swing.JLabel lblTitle;
    private javax.swing.JPanel panScreen;
    private javax.swing.JTextField txtFrameRate;
    // End of variables declaration//GEN-END:variables
    public javax.swing.JPanel screen;
}
