package audiovideo;
        
import java.awt.image.BufferedImage;
import java.io.*;
import java.net.Socket;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.sound.sampled.*;

/**
 *
 * @author user
 */
public class ClientAudio {

    static Socket client,  clientVideo;
    static OutputStream out;
    static InputStream in;
    static ObjectInputStream inVideo;
    static ObjectOutputStream outVideo;
    static final AudioFormat format = getFormat();
    static ArrayList<byte[]> audioBuffer = new ArrayList<byte[]>(10);
    static BufferedImage image;
    static CapturePlaybackThread videoCaptureThread;
    static public BufferedImage theBufImg;
    

//    static ByteArrayOutputStream byteOut;
    public static void main(String[] args) throws InterruptedException {
        try {
            /*if (args[0].equals("true")) {
                Framework.hasTheFloor = true;
            } else {
                Framework.hasTheFloor = false;
            }*/
            
            Framework.hasTheFloor = true;
            Framework.hasMicrophone = true;
            Framework.hasWebcam = true;

            if (Framework.hasMicrophone) { // MICROPHONE AVAILABLE
                // Creation of the socket
                client = new Socket("127.0.0.1", 8080);

                // Collection of input/output streams
                out = client.getOutputStream();
                in = client.getInputStream();
            }

            if (Framework.hasWebcam) { // WEBCAM AVAILABLE
                // Cration of the socket
                clientVideo = new Socket("127.0.0.1", 8081);

                // Collection of input/output Streams
                outVideo = new ObjectOutputStream(clientVideo.getOutputStream());
                inVideo = new ObjectInputStream(clientVideo.getInputStream()); // clientVideo.getInputStream();

                // START RECEPTION AND PLAY BACK
                receivAndPlayback();
            }

            // Display the GUI
//            videoCaptureThread = new CapturePlaybackThread();
            videoCaptureThread.start();

            // START CAPTURING AND STREAMING
            captureAndStream();

        } catch (LineUnavailableException ex) {
            Logger.getLogger(ClientAudio.class.getName()).log(Level.SEVERE, null, ex);
        } catch (UnknownHostException ex) {
            Logger.getLogger(ClientAudio.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(ClientAudio.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    static private void captureAndStream() throws LineUnavailableException {
        // ******************************
        // AUDIO CAPTURE AND STREAMING **
        // ******************************
        // ******************************
        if (Framework.hasMicrophone && Framework.hasTheFloor) {
            System.out.println("Audio capture initialization");
            DataLine.Info info = new DataLine.Info(
                    TargetDataLine.class, format);
            final TargetDataLine line = (TargetDataLine) AudioSystem.getLine(info);
            line.open(format);
            line.start();


            Runnable runner = new Runnable() {

                int bufferSize = (int) (format.getSampleRate() * format.getFrameSize());
                byte buffer[] = new byte[bufferSize];

                public void run() {
                    try {
                        System.out.println("Capture and streaming started");
                        int i = 0;
                        while (true) {
                            int count = line.read(buffer, 0, buffer.length);
                            if (count > 0) {
                                out.write(buffer, 0, count);
                            }
                            i++;
                            System.out.println("packet " + i);

                        }
//                    out.close();
                    } catch (Exception ex) {
                        ex.printStackTrace();
                        Logger.getLogger(ClientAudio.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
            };
            Thread captureThread = new Thread(runner);
            captureThread.start();
        }

        // ******************************
        // VIDEO CAPTURE AND STREAMING **
        // ******************************
        if (Framework.hasWebcam && Framework.hasTheFloor) {
            Runnable runnerVideo = new Runnable() {

                public void run() {
                    try {
                        while (true) {
                            image = videoCaptureThread.image;
                            if (image != null) {
                                ByteArrayOutputStream baos = new ByteArrayOutputStream();
                                ImageIO.write(image, "JPEG", baos);
                                byte[] buf = baos.toByteArray();
//                                outVideo.flush();
                                outVideo.writeObject(buf);
//                            clientVideo.getOutputStream().flush();
//                            ImageIO.write(image, "JPG", clientVideo.getOutputStream());
                                Thread.sleep(Framework.IMAGE_DURATION);
                                System.out.println("Image sent, packet size " + buf.length);
                            }
                        }
                    } catch (Exception ex) {
                        Logger.getLogger(ClientAudio.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
            };
            Thread captureThreadVideo = new Thread(runnerVideo);
            captureThreadVideo.start();
        }
    }

    static private void receivAndPlayback() {
        System.out.println("receivAndPlayback");
        videoReceptionAndPlayback();
        audioReceptionAndPlayback();
    }

    static private void audioReceptionAndPlayback() {
        Runnable playBack = new Runnable() {

            public void run() {
                final AudioFormat format = getFormat();

                try {
                    while (true) {
                        if (!Framework.hasTheFloor) {
                            System.out.println("Creation of Audio Input Stream");
                            final AudioInputStream ais =
                                    new AudioInputStream(in, format, 10000000);

                            System.out.println("Creation of Data Line and Source data line");
                            DataLine.Info info = new DataLine.Info(
                                    SourceDataLine.class, format);

                            final SourceDataLine line = (SourceDataLine) AudioSystem.getLine(info);

                            line.open(format);
                            line.start();

                            System.out.println("Line started");

                            int bufferSize = (int) format.getSampleRate() * format.getFrameSize();
                            byte buffer[] = new byte[bufferSize];

                            System.out.println("Buffer initialized");

                            try {
                                int count;
////                                long skipped = in.skip(1000000);
//                                System.out.println("Number of byte skipped "+skipped);
                                emptyTheBuffer(ais, line);
                                int k = 0;
                                while ((count = ais.read(
                                        buffer, 0, buffer.length)) != -1) { //
//                                    System.out.println("Packet read, count :" + count);
                                    if (count == bufferSize) {
                                        line.flush();
                                    }
                                    if (count > 0) {
                                        line.write(buffer, 0, count);
//                                        System.out.println("Packet written on the line");
                                    }
                                }

                                line.drain();
                                line.close();
                            } catch (Exception e) {
                                System.err.println("I/O problems: " + e);
                                System.exit(-3);
                            }
                        }
                    }

                } catch (LineUnavailableException ex) {
                    Logger.getLogger(ClientAudio.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        };

        Thread threadPlayback = new Thread(playBack);
        threadPlayback.start();
    }

    static private void videoReceptionAndPlayback() {
        System.out.println("Method videoReceptionAndPlayback");
        Runnable receivImage = new Runnable() {

            public void run() {

                System.out.println("Image reception preparation");
//                byte[] buf = new byte[100000];
                byte[] imgBuf;
//                inVideo.skipBytes(10000);
                // Flush the image buffer
//                try{inVideo.readFully(buf);
//                }catch(IOException ex){ex.printStackTrace();}

                // Buffer flushing
//                emptyTheBuffer();
                try{emptyTheBuffer();}catch(Exception ex){ex.printStackTrace();}
                int size = 0;
                
                byte[] bufSize = new byte[5];

                while (true) {
                    try {
                        if (inVideo != null) {
                            //image = (BufferedImage) inVideo.readObject();
                            Thread.sleep(Framework.IMAGE_DURATION);
//                            size = inVideo.read(imgBuf);

                            // Read the size of the buffer
                            //inVideo.skip(10000);
//                            inVideo.read(bufSize, 0, 5);
//                            size = byteArrayToInt(bufSize);

                            // Read the byte array
//                            imgBuf = new byte[10000];
//                            inVideo.read(imgBuf, 0, 10000);
                            imgBuf = (byte[]) inVideo.readObject();
//                            imgBuf = new byte[1];
//                            String test = (String) inVideo.readObject();
                            
//                            System.out.println("Here is the test entered : "+test);
                            
                            ByteArrayInputStream bais = new ByteArrayInputStream(imgBuf, 0, imgBuf.length);
                            theBufImg = ImageIO.read(bais);
                            Framework.theBufImg = theBufImg;
//                            videoCaptureThread.image = theBufImg;

                            //videoCaptureThread.image
                            System.out.println(" Image received : " + imgBuf.length);

                            if (theBufImg == null) {
                                System.out.println("Buff Image null");
                            } else {
                                System.out.println("COOOL, the buff is not null !!!");
//                                JFrame fen = new JFrame("Win");
//                                fen.getContentPane().add(new JLabel(new ImageIcon(theBufImg)));
//                                fen.pack();
//                                fen.setVisible(true);
                            }
                            

                        }

                    } catch (IOException ex) {
                        Logger.getLogger(ClientAudio.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (ClassNotFoundException ex) {
                        Logger.getLogger(ClientAudio.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(ClientAudio.class.getName()).log(Level.SEVERE, null, ex);
                    }

                }

            }
        };

        Thread threadReceivImage = new Thread(receivImage);
        threadReceivImage.start();
    }

    static private void emptyTheBuffer(AudioInputStream ais, SourceDataLine line) throws IOException {
        //ais.skip(1000000);
        
        long time;
        int i = 1;
        byte[] buffer = new byte[8000];
        System.out.println("Buffer flushing ..");
        while (true) {
//            System.out.println("Buffer flushing " + i++);
            time = System.currentTimeMillis();
            ais.read(buffer);
            line.flush();
//            System.out.println("Time elapsed " + (System.currentTimeMillis() - time));

            if (System.currentTimeMillis() - time > 800) {
                System.out.println("End of flushing " + (System.currentTimeMillis() - time));

                return;
            }
        }
    }

    static private void emptyTheBuffer() throws IOException, ClassNotFoundException {
        long time;
        int i = 0;
//        byte[] buffer = new byte[10000];
        System.out.println("Video buffer flushing");
        int size = 0;
        Object ob;
        while (true) {
            i++;
            time = System.currentTimeMillis();
            try {
//                size = inVideo.read(buffer);
                ob = inVideo.readObject();

                System.out.println("[" + size + "]Time elapsed (video) " + (System.currentTimeMillis() - time));

                if (System.currentTimeMillis() - time > 800) {
                    System.out.println("End of video buffer flushing");
                    return;
                }

            } catch (IOException e) {
            }
        }
//        System.out.println("End of video buffer flushing");
    }

    static private AudioFormat getFormat() {
        float sampleRate = 8000;
        int sampleSizeInBits = 8;
        int channels = 1;
        boolean signed = true;
        boolean bigEndian = true;
        return new AudioFormat(sampleRate,
                sampleSizeInBits, channels, signed, bigEndian);
    }

    static private int byteArrayToInt(byte[] b) {
        String number = "";
        for (int i = 0; i < 5; i++) {
            number += b[i];
        }

        System.out.println("The number is : " + number);

        return Integer.parseInt(number);
    }
//        int value = 0;
//        for (int i = 0; i < 4; i++) {
//            int shift = (4 - 1 - i) * 8;
//            value += (b[i + offset] & 0x000000FF) << shift;
//        }
//        return value;
}
