package audiovideo;

import java.awt.Color;
import java.awt.image.BufferedImage;
import java.io.*;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import java.util.*;

/**
 * This class holds shared ressources (objects) that will used
 * by several other external classes
 * 
 * @author Tresor Mvumbi
 */
public class Framework {

    public static String clientId; // Id of the current client
    public static String participantName; // Name of the current user
    public static String meetingId; // Id of the current meeting
    public static int seqNumber = 1; // Will be used to uniquely identily each packet
    public static String clientHoldingFloor; // Id of the client holding the floor
    public static boolean hasTheFloor = false; // Flag determining if the current user hold the floor
    public static boolean hasWebcam = false; // Does the current client have a webcam ?
    public static boolean hasMicrophone = false; // Does the current client have a microphone ?    
    public static boolean quit = false; // Takes true to stop all the thread (before quitting the application)
    public static boolean broadCastVisible = false;
    public static long SOUND_PACKET_DURATION = 1000;
    public static long IMAGE_DURATION = 1000;
    public static String servletURL = "";
    static public BufferedImage theBufImg;
    
    static public int packetNumber = 0;

    public static void copyBufferedImage(BufferedImage img1, BufferedImage img2) {
        int w = img1.getWidth();
        int h = img1.getHeight();

        if (w != img2.getWidth() || h != img2.getHeight()) {
            System.err.println("Image copy error : the two images should have the same size");
            return;
        }

        for (int i = 0; i < w; i++) {
            for (int j = 0; j < h; j++) {
                img2.setRGB(i, j, img1.getRGB(i, j));
            }
        }
    }

    public static void imageDiff(BufferedImage img1, BufferedImage img2) {
//        long time1 = System.currentTimeMillis();
        int w = img1.getWidth();
        int h = img1.getHeight();

        if (w != img2.getWidth() || h != img2.getHeight()) {
            System.err.println("Image Diff error : the two images should have the same size");
            return;
        }

        for (int i = 0; i < w; i++) {
            for (int j = 0; j < h; j++) {
                
                int px1 = img1.getRGB(i, j);
                int px2 = img2.getRGB(i, j);
                Color col1 = new Color(px1);
                Color col2 = new Color(px2);
                int r = 127 - (col2.getRed() - col1.getRed())/2;
                int g = 127 - (col2.getGreen() - col1.getGreen())/2;
                int b = 127 - (col2.getBlue() - col1.getBlue())/2;
                
//                if (i==100 && j==100)
//                    System.out.println("col1 source = "+col1.getRed());
                
//                if (g>225) System.out.println("Green = "+g);
//                if (g<0) System.out.println("Green = "+g);
                
                if (r>255) r = 255;
                if (g>255) g = 255;
                if (b>255) b = 255;

                if (r<2) r = 0;
                if (g<2) g = 0;
                if (b<2) b = 0;
                
                Color colDiff = new Color(r,g,b);
                img2.setRGB(i, j, colDiff.getRGB());
            }
        }
        
//        long time2 = System.currentTimeMillis();
//        System.out.println("Time = "+(time2-time1));
    }

    public static void imageAddition(BufferedImage img1, BufferedImage img2) {
        int w = img1.getWidth();
        int h = img1.getHeight();

        if (w != img2.getWidth() || h != img2.getHeight()) {
            System.err.println("Image Diff error : the two images should have the same size");
            return;
        }

        for (int i = 0; i < w; i++) {
            for (int j = 0; j < h; j++) {
                int px1 = img1.getRGB(i, j);
                int px2 = img2.getRGB(i, j);
                Color col1 = new Color(px1);
                Color col2 = new Color(px2);
                int r = col1.getRed() + 2*(127 - col2.getRed());
                int g = col1.getGreen() + 2*(127 - col2.getGreen());
                int b = col1.getBlue() + 2*(127 - col2.getBlue());
                
//                if (i==100 && j==100)
//                    System.out.println("col1 dest = "+col1.getRed());
                
//                if (g>255) System.out.println("Green = "+g);
//                if (g<0) System.out.println("Green = "+g);
                
                if (r>255) r = 255;
                if (g>255) g = 255;
                if (b>255) b = 255;
                
                if (r<0) r = 0;
                if (g<0) g = 0;
                if (b<0) b = 0;
                
                Color colAdd = new Color(r,g,b);
                img1.setRGB(i, j, colAdd.getRGB());
            }
        }
    }    
    
    public static File[] getFileListSorted(File directory) {
        File[] files = directory.listFiles();

        Arrays.sort(files, new Comparator<File>() {

            public int compare(File f1, File f2) {
//                return Long.valueOf(f1.lastModified()).compareTo(f2.lastModified());
                return (f1.getName().compareTo(f2.getName()));
            }
        });

        return files;
    }

    public static String formatSequenceNumber(int number) {
        if (number < 10) {
            return "00000" + number;
        } else if (number < 100) {
            return "0000" + number;
        } else if (number < 1000) {
            return "000" + number;
        } else if (number < 10000) {
            return "00" + number;
        } else if (number < 100000) {
            return "00" + number;
        } else if (number < 1000000) {
            return "0" + number;
        } else {
            return "" + number;
        }
    }
}
