package audiovideo;

import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;

/**
 * This class is responsible for uploading files using http
 * 
 * @author Tresor Mvumbi
 */
public class HttpBinaryTransfer {

    public static void main(String args[]) {

        try {
            byte[] buf = new byte[1];
            sendPacket(new byte[4000], "http://localhost:8080/face/MultimediaServlet", "video", "nathan", "congres",2);
//            receivPackets(buf, "http://localhost:8080/face/MultimediaServlet", "video", "nathan", "congres");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void sendPacket(byte[] buf, String uri, String type,
            String user, String meeting, int packetNumber) throws Exception {

        URL url = new URL(uri + "?direction=upload&size=" + buf.length + 
                "&type=" + type + "&user=" + user + 
                "&meeting=" + meeting+"&packetnumber="+packetNumber+"&source="+user);

        String boundary = Long.toHexString(System.currentTimeMillis()); // Just generate some unique random value.
        String CRLF = "\r\n"; // Line separator required by multipart/form-data.
        String charset = "UTF-8";

        URLConnection connection = url.openConnection();
        connection.setDoOutput(true);
        connection.setDoInput(true);
        connection.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + boundary);
        PrintWriter writer = null;
        try {
            OutputStream output = connection.getOutputStream();
//            ObjectOutputStream os = new ObjectOutputStream(output);

            writer = new PrintWriter(new OutputStreamWriter(output, charset), true); // true = autoFlush, important!

            // Send binary file.
            writer.append("--" + boundary).append(CRLF);
            writer.append("Content-Disposition: form-data; name=\"binaryFile\"; filename=\"fileName\"").append(CRLF);
            writer.append("Content-Type: image/gif");
            writer.append("Content-Transfer-Encoding: binary").append(CRLF);
            writer.append(CRLF).flush();
//            os.writeObject(buf);
//            os.flush();
            output.write(buf);
            output.flush(); // Important! Output cannot be closed. Close of writer will close output as well.
            writer.append(CRLF).flush(); // CRLF is important! It indicates end of binary boundary.

            // End of multipart/form-data.
            writer.append("--" + boundary + "--").append(CRLF);
//            System.out.println("Done !");
        } finally {
            if (writer != null) {
                writer.close();
                connection.getInputStream();
//                System.out.println(type + " packet sent ! [size=" + buf.length + "]");
            }
        }
    }

    public static ArrayList receivPackets(String uri, String type, String user, String meeting) {
        while (true) {
            try {
                String boundary = Long.toHexString(System.currentTimeMillis());
                URL u = new URL(uri + "?direction=download&type=" + type + "&user=" + user + "&meeting=" + meeting+"&source="+user);
                URLConnection c = u.openConnection();
//                c.setDoOutput(true);
                c.setDoInput(true);
                c.setUseCaches(false);
                // set some request headers
                c.setRequestProperty(
                        "Connection",
                        "Keep-Alive");

//                Thread.sleep(500);
//                System.out.println("Waiting for the input");
                InputStream in = c.getInputStream();
                ObjectInputStream oi = new ObjectInputStream(in);

//                
//                while (true) {
//                    System.out.println("Waiting to read");
                ArrayList buf = (ArrayList) oi.readObject();

//                    ByteArrayInputStream bais = new ByteArrayInputStream(buf, 0, buf.length);
//                    Framework.theBufImg = ImageIO.read(bais);
                byte [] p = (byte []) buf.get(0);

//                System.out.println(type + " packet read, size " + p.length);

                return buf;
//                }
            } catch (Exception e) {
                try {
                    e.printStackTrace();
                    Thread.sleep(3000);
                } catch (InterruptedException ex) {
                }
            }
        }
    }

    public static String whoIsHoldingTheFloor(String uri, String meeting) {
        try {
            String boundary = Long.toHexString(System.currentTimeMillis());
            URL u = new URL(uri + "?direction=floor&meeting=" + meeting);
            URLConnection c = u.openConnection();
            c.setDoInput(true);
            c.setUseCaches(false);
            // set some request headers
            c.setRequestProperty(
                    "Connection",
                    "Keep-Alive");

            InputStream in = c.getInputStream();
            ObjectInputStream oi = new ObjectInputStream(in);

            String user = (String) oi.readObject();

//            System.out.println("The floor is held by  " + user);

            return user;
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
    }
}
