/*
 * ReceptionStream.java
 *
 * Created on September 9, 2011, 2:06 PM
 */
package audiovideo;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.LinkedList;
import java.util.Queue;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.zip.DataFormatException;
import java.util.zip.Inflater;
import javax.imageio.ImageIO;
//import javax.media.format.AudioFormat;
import javax.sound.sampled.*;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import org.tritonus.sampled.convert.gsm.GSMFormatConversionProvider;

/**
 *
 * @author  user
 */
public class ReceptionStream extends javax.swing.JFrame {

    String user;
    String meeting;
    boolean receivVideo = true;
    boolean receivSound = true;
    private boolean receptionActive = true;
    public long IMAGE_DURATION = 1000;
    PipedOutputStream pou;
    PipedInputStream pin;
    ByteArrayOutputStream bou;
    byte[] audioBuffer = new byte[1];
    boolean pause = false;
    long savedTime = 0;
    double bufferedTime = 0;
    Queue<byte[]> soundQueue = new LinkedList<byte[]>();
    int timeElapsed[] = new int[10];
    long lastTime = 0;

    /** Creates new form ReceptionStream */
    public ReceptionStream(String _user, String _meeting) {
        initComponents();
        user = _user;
        meeting = _meeting;

        if (new File("image_" + user + "_" + meeting + ".jpg").exists()) {
            new File("image_" + user + "_" + meeting + ".jpg").delete();
        }

        cmdPlay.setIcon(new javax.swing.ImageIcon(getClass().getResource("play.png")));
        cmdPause.setIcon(new javax.swing.ImageIcon(getClass().getResource("pause.png")));
        cmdFastFoward.setIcon(new javax.swing.ImageIcon(getClass().getResource("fast.png")));

        cmdCongestion.setIcon(new javax.swing.ImageIcon(getClass().getResource("no_congestion.png")));
        cmdCongestion.setDisabledIcon(new javax.swing.ImageIcon(getClass().getResource("no_congestion.png")));

//        Framework.hasTheFloor = false;
        videoReceptionAndPlayback();
        audioReceptionAndPlayback();

        // initialization of the array
        for (int i = 0; i < 10; i++) {
            timeElapsed[i] = 0;
        }
    }

    private void videoReceptionAndPlayback() {
        System.out.println("Method videoReceptionAndPlayback");
        Runnable receivImage = new Runnable() {

            public void run() {
                while (receptionActive) {
                    if (receivVideo) {
                        try {
                            long time1 = System.currentTimeMillis();
//                    System.out.println("Image reception preparation");
                            byte[] buf;

                            ArrayList packet = HttpBinaryTransfer.receivPackets(
                                    Framework.servletURL,
                                    "video",
                                    user,
                                    meeting);

                            buf = (byte[]) packet.get(0);
                            String strPackNb = (String) packet.get(1);

                            if (Framework.packetNumber == Integer.parseInt(strPackNb)) {
                                continue;
                            }
                            Framework.packetNumber = Integer.parseInt(strPackNb);

                            Calendar cal = Calendar.getInstance();
                            SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");

//                            System.out.println(sdf.format(cal.getTime()) + " " + Framework.packetNumber);

//                            System.out.println("Packet received number " + packetNumber);

                            ByteArrayInputStream bais = new ByteArrayInputStream(buf, 0, buf.length);

                            if (Framework.packetNumber % 10 != 0) {
                                if (Framework.theBufImg == null) {
                                    continue;
                                }
                                Framework.imageAddition(Framework.theBufImg,
                                        ImageIO.read(bais));
                            } else {
                                Framework.theBufImg = ImageIO.read(bais);
                            }

//                            BufferedImage image = Framework.theBufImg;

                            // Image addition
                            /*
                            if (new File("image_"+user+"_"+meeting+".jpg").exists()) {
                            BufferedImage bi = ImageIO.read(new File("image_"+user+"_"+meeting+".jpg"));
                            int w = image.getWidth();
                            int h = image.getHeight();
                            for (int i = 0; i < w; i++) {
                            for (int j = 0; j < h; j++) {
                            int pxImg = image.getRGB(i, j);
                            int pxBuff = bi.getRGB(i, j);
                            Color colImg = new Color(pxImg);
                            Color colBuff = new Color(pxBuff);
                            int r,g,b;
                            r = colBuff.getRed() + colImg.getRed();
                            if (r>255){
                            r = Math.abs(colBuff.getRed() - colImg.getRed());
                            }
                            g = colBuff.getGreen() + colImg.getGreen();
                            if (g>255){
                            g = Math.abs(colBuff.getGreen() - colImg.getGreen());
                            }
                            b = Math.abs(colBuff.getBlue() + colImg.getBlue());
                            if (b>255){
                            b = Math.abs(colBuff.getBlue() - colImg.getBlue());
                            }
                            Color colDiff = new Color(r,g,b);
                            bi.setRGB(i, j, colDiff.getRGB());
                            image = bi;
                            }
                            }
                            }*/

                            /*
                            ImageIO.write(image,
                            "jpg",
                            new File("image_"+user+"_"+meeting+".jpg"));
                            ImageIO.write(image,
                            "jpg",
                            new File("image_"+user+"_"+meeting+"_"+System.currentTimeMillis()+ ".jpg"));
                             */


                            long time2 = System.currentTimeMillis();
//                            Thread.sleep(IMAGE_DURATION);
                            long delay = IMAGE_DURATION - (time2 - time1);


                            if (delay > 0) {
                                Thread.sleep(delay);
                            }
                            long time3 = System.currentTimeMillis();
//                            System.out.println("Delay = " + (time3 - time1));
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        };

        Thread threadReceivImage = new Thread(receivImage);
        threadReceivImage.start();

        Runnable videoPlayBack = new Runnable() {

            public void run() {

                while (receptionActive) {
                    if (receivVideo) {
                        try {
                            videoPlayBack();
                            Thread.sleep(IMAGE_DURATION);
                        } catch (InterruptedException ex) {
                            Logger.getLogger(ReceptionStream.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                }
            }
        };

        Thread threadVideoPlayBack = new Thread(videoPlayBack);
        threadVideoPlayBack.start();
    }

    private void videoPlayBack() {
        try {
            if (Framework.theBufImg != null) {
                ImageIcon icon = new ImageIcon(Framework.theBufImg);
                lblScreen.setIcon(icon);
                this.getContentPane().repaint();
                this.repaint();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void audioReceptionAndPlayback() {
        pou = new PipedOutputStream();

        Runnable playBack = new Runnable() {

            public void run() {
                final AudioFormat format = Broadcast.getFormat();

                try {
                    pin = new PipedInputStream(pou);
                    bou = new ByteArrayOutputStream();

                    while (receptionActive) {
                        if (receivSound) {
                            if (audioBuffer.length == 1) {
//                                System.out.println("Length 1");
//                                Thread.sleep(1000);
                                continue;
                            }

                            System.out.println("Creation of Audio Input Stream, size = " + audioBuffer.length);

//                            AudioFormat gsmFormat = AudioSystem.getAudioInputStream(new ByteArrayInputStream(audioBuffer)).getFormat();
//                            final AudioInputStream aisGSM = new AudioInputStream(pin,gsmFormat,10000000);
//                            System.out.println(gsmFormat);
//                            
//                            
//                            
//                            AudioFormat.Encoding targetEncoding = AudioFormat.Encoding.PCM_SIGNED;
//                            final AudioInputStream ais = AudioSystem.getAudioInputStream(targetEncoding, aisGSM);
//                            System.out.println(ais.getFormat());



                            final AudioInputStream ais =
                                    new AudioInputStream(pin, format, 10000000);

//                            final AudioInputStream aisGSM;
//                            AudioFormat sourceFormat = ais.getFormat();
//                            AudioFormat.Encoding targetEncoding = AudioFormat.Encoding.PCM_SIGNED;
//                            aisGSM = AudioSystem.getAudioInputStream(targetEncoding, ais);

                            System.out.println("Creation of Data Line and Source data line");
                            DataLine.Info info = new DataLine.Info(
                                    SourceDataLine.class, format);

                            final SourceDataLine line = (SourceDataLine) AudioSystem.getLine(info);

                            line.open(format);
                            line.start();

                            System.out.println("Line started");

                            int bufferSize = (int) format.getSampleRate() * format.getFrameSize();
                            byte buffer[] = new byte[bufferSize / 1];

                            System.out.println("Buffer initialized");

                            try {
                                int count;
////                                long skipped = in.skip(1000000);
//                                System.out.println("Number of byte skipped "+skipped);
//                                emptyTheBuffer(ais, line);

                                int k = 0;
                                while (true) { //
                                    if (!pause) {
//                                        count = aisGSM.read(buffer, 0, buffer.length);
                                        count = ais.read(buffer, 0, buffer.length);
                                        if (count == -1) {
                                            break;
                                        }
                                        if (count == bufferSize) {
                                            line.flush();
                                        }
                                        if (count > 0) {
//                                            byte[] audioBuf = decompressAudio(buffer);
//                                            line.write(audioBuf, 0, audioBuf.length);
                                            line.write(buffer, 0, count);
//                                            System.out.println("Something written in the buffer : "+buffer.length);
//                                            line.write(decompressAudio(buffer), 0, decompressAudio(buffer).length);
                                        }
                                    } else {
                                        long curTime = System.nanoTime();
                                        long timeSpan = curTime - savedTime;
                                        savedTime = curTime;
                                        bufferedTime += timeSpan;
                                        double bufTime = Math.round(bufferedTime / 100000000);
                                        bufTime /= 10;
                                        lblBuffered.setText(soundQueue.size() + " sec buffered");
                                    }
                                }

                                line.drain();
                                line.close();
                            } catch (Exception e) {
                                System.err.println("I/O problems: " + e);
                                e.printStackTrace();
//                                System.exit(-3);
                            }
                        }
                    }

                } catch (Exception ex) {
                    ex.printStackTrace();
//                    Logger.getLogger(ClientAudio.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        };

        Thread threadPlayback = new Thread(playBack);
        threadPlayback.start();

        //////////////////////////////////////////////////////////
        // PACKET RECEPTION AND WRITING INTO A LOCAL STREAM //////
        //////////////////////////////////////////////////////////
        Runnable audioReception = new Runnable() {

            public void run() {
                try {
                    while (receptionActive) {
                        if (receivSound) {
//                    System.out.println("Image reception preparation");
                            byte[] buf;

                            ArrayList packet = HttpBinaryTransfer.receivPackets(
                                    Framework.servletURL,
                                    "audio",
                                    user,
                                    meeting);

                            buf = (byte[]) packet.get(0);

                            if (user.equals("__floor__")) {
                                String theUserWithFloor = HttpBinaryTransfer.whoIsHoldingTheFloor(Framework.servletURL, meeting);
                                lblTitle.setText("Reception Stream. User : " + theUserWithFloor + ", Meeting: " + meeting);
                            }

                            if (!Arrays.equals(buf, audioBuffer)) {
//                                if (!pause) {
//                                    if (bou.size()>0){
//                                        pou.write(bou.toByteArray());
//                                        bou.reset();
//                                    }

                                // Write the packet into a queue
                                //soundQueue.add(buf);
//                                System.out.println("Sice of : "+buf.length);
                                soundQueue.add(unzipAudio(buf));//

//                                System.out.println("THE BUF SIZE = " + buf.length);
                                audioBuffer = new byte[buf.length];
                                System.arraycopy(buf, 0, audioBuffer, 0, buf.length);
//                                System.out.println("Packet buffered, size = " + audioBuffer.length);                                

                                if (!pause) {
                                    byte[] bufSnd = soundQueue.poll();
//                                    System.out.println("Before pipe" );
                                    pou.write(bufSnd);
//                                    System.out.println("After pipe" );
                                }

                                // calculatio of time between packets
                                if (lastTime == 0) {
                                    lastTime = System.currentTimeMillis();
                                }
                                int diff = Math.round((System.currentTimeMillis() - lastTime) / 1000);
//                                int sum = diff;
                                int sum = 0;

                                // saving the time and calculating the average
                                timeElapsed[9] = diff;
                                for (int i = 0; i < 9; i++) {
                                    timeElapsed[i] = timeElapsed[i + 1];
                                }

                                for (int i = 0; i < 10; i++) {
                                    sum += timeElapsed[i];
//                                    System.out.print("v "+i+" = "+timeElapsed[i]+" ");
                                }


                                lastTime = System.currentTimeMillis();

//                                System.out.println("Delay "+diff +", Sum: "+sum);

                                int avg = Math.round(sum / 10);

                                if (avg >= 3) { // congestion spotted !
                                    if (chkAutoBW.isSelected()) {
                                        if (avg <= 4) {
                                            IMAGE_DURATION = 5000;
                                            txtFrameRate.setText("0.2");
                                        } else {
                                            cmbMediaType.setSelectedIndex(1);
                                            txtFrameRate.setText("0.1");
                                            receivVideo = false;
                                            receivSound = true;
                                        }
                                    }
                                    cmdCongestion.setIcon(new javax.swing.ImageIcon(getClass().getResource("congestion.png")));
                                    cmdCongestion.setDisabledIcon(new javax.swing.ImageIcon(getClass().getResource("congestion.png")));
                                } else {
                                    cmdCongestion.setIcon(new javax.swing.ImageIcon(getClass().getResource("no_congestion.png")));
                                    cmdCongestion.setDisabledIcon(new javax.swing.ImageIcon(getClass().getResource("no_congestion.png")));
                                }


//                                    System.out.println("SND WRITTEN");
//                                } else {
//                                    bou.write(buf);
//                                    System.out.println("SND BUFFERED");
//                                }
                            } else {
                                int diff = Math.round((System.currentTimeMillis() - lastTime) / 1000);
                                if (chkAutoBW.isSelected() && diff > 10) {
                                    //If nothing is received since more than 10 sec, 
                                    // spot a congestion
                                    cmbMediaType.setSelectedIndex(1);
                                    txtFrameRate.setText("0.2");
                                    receivVideo = false;
                                    receivSound = true;

                                    cmdCongestion.setIcon(new javax.swing.ImageIcon(getClass().getResource("congestion.png")));
                                    cmdCongestion.setDisabledIcon(new javax.swing.ImageIcon(getClass().getResource("congestion.png")));
                                }
                            }

                            try {
//                            Thread.sleep(1000); // this will add an additional delay, as it takes a while to communicate with the server ...
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    }
                } catch (Exception e) {
                    System.err.println("Pipe error");
                    e.printStackTrace();
                }
            }
        };

        Thread threadAudioReception = new Thread(audioReception);
        threadAudioReception.start();

    }

    static private void emptyTheBuffer(AudioInputStream ais, SourceDataLine line) throws IOException {

//        if (true)return;
        //ais.skip(1000000);

        long time;
        int i = 1;
        byte[] buffer = new byte[16000];
        System.out.println("Buffer flushing ..");
        while (true) {
            i++;
            if (i > 5) {
                return;
            }
//            System.out.println("Buffer flushing " + i++);
            time = System.currentTimeMillis();
            ais.read(buffer);
            line.flush();
//            System.out.println("Time elapsed " + (System.currentTimeMillis() - time));

            if (System.currentTimeMillis() - time > 800) {
                System.out.println("End of flushing " + (System.currentTimeMillis() - time));

                return;
            }
        }
    }

//    static private AudioFormat getFormat() {
//        float sampleRate = 8000;
//        int sampleSizeInBits = 16;
//        int channels = 1;
//        boolean signed = true;
//        boolean bigEndian = true;
//        return new AudioFormat(sampleRate,
//                sampleSizeInBits, channels, signed, bigEndian);
//    }
    static public byte[] decompressAudio(byte[] sndBuffer) throws IOException, Exception {

//        AudioInputStream normal = AudioSystem.getAudioInputStream(new ByteArrayInputStream(sndBuffer));
//        System.out.println(normal.getFormat());
//        System.out.println("Packet size received : " + sndBuffer.length);
//        
//        File file = new File("soundPacketRec.spx");
//        Broadcast.writeIntoFile(sndBuffer, file);
//        JSpeexDec.main(new String[]{"soundPacketRec.spx", "soundPacketRec.v"});
//        
//        byte[] decompressedBuf = Broadcast.readFromFile(new File("soundPacketRec.v"));
//        
//        System.out.println("Packet size decompressed : " + decompressedBuf.length);
//        return decompressedBuf;

//        ByteArrayInputStream bis = new ByteArrayInputStream(sndBuffer);
        ByteArrayOutputStream bos = new ByteArrayOutputStream();

//        AudioFormat.Encoding encoding = new AudioFormat.Encoding("GSM0610");
//        AudioFormat.Encoding encoding = AudioFormat.Encoding.ULAW;
//        AudioFormat.Encoding encoding = new AudioFormat.Encoding("MPEG1L3");
//        AudioFormat af = new AudioFormat(encoding, 8000, 16, 1, -1,-1, true);//33,50

//        AudioFormat af = new AudioFormat(
//                encoding,
//                8000,
//                -1,
//                1,
//                33,
//                50,
//                false);

//        AudioInputStream aisGSM = new AudioInputStream(bis, af, sndBuffer.length);
        AudioInputStream aisGSM = AudioSystem.getAudioInputStream(new ByteArrayInputStream(sndBuffer));
//        AudioSystem.getAudioIn



        AudioFormat.Encoding targetEncoding = AudioFormat.Encoding.PCM_SIGNED;
        AudioInputStream ais = AudioSystem.getAudioInputStream(targetEncoding, aisGSM);//Mp3Encoder.getConvertedStream(aisGSM, targetEncoding);
//        System.out.println("After MP3 encoding. Format " + ais.getFormat());

        AudioFileFormat.Type fileType = AudioFileFormat.Type.AU;
        ByteArrayOutputStream baos = new ByteArrayOutputStream();



        byte[] unzipBuffer = new byte[17000];

//        int n = ais.read(unzipBuffer, 0, unzipBuffer.length);
//        System.out.println("SIZE = " + n);

        int numBytes = 1;
        while (true) {
//            System.out.println("before reading");
//            numBytes = AudioSystem.write(ais, fileType, baos);
            numBytes = ais.read(unzipBuffer, 0, unzipBuffer.length);
//            System.out.println("after reading: " + numBytes);
//            System.out.print("num "+numBytes);

            if (numBytes <= 0) {
                break;
            }
//            System.out.println(""+numBytes);
            bos.write(unzipBuffer, 0, numBytes);
//            break;
        }

        byte[] returnBuffer = bos.toByteArray();
//        byte[] returnBuffer = baos.toByteArray();

        System.out.println("Length reception = " + returnBuffer.length);


        return returnBuffer;
    }

    static public byte[] unzipAudio(byte[] compressedData) {
        // Create the decompressor and give it the data to compress
        Inflater decompressor = new Inflater();
        decompressor.setInput(compressedData);

        // Create an expandable byte array to hold the decompressed data
        ByteArrayOutputStream bos = new ByteArrayOutputStream(compressedData.length);

        // Decompress the data
        byte[] buf = new byte[1024];
        while (!decompressor.finished()) {
            try {
                int count = decompressor.inflate(buf);
                bos.write(buf, 0, count);
            } catch (DataFormatException e) {
            }
        }
        try {
            bos.close();
        } catch (IOException e) {
        }

// Get the decompressed data
        byte[] decompressedData = bos.toByteArray();
        
        return decompressedData;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lblTitle = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        lblBuffered = new javax.swing.JLabel();
        lblScreen = new javax.swing.JLabel();
        cmdPlay = new javax.swing.JButton();
        cmdPause = new javax.swing.JButton();
        cmdFastFoward = new javax.swing.JButton();
        cmdClose = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        cmbMediaType = new javax.swing.JComboBox();
        jLabel7 = new javax.swing.JLabel();
        txtFrameRate = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        cmdSet = new javax.swing.JButton();
        chkAutoBW = new javax.swing.JCheckBox();
        lblCongestion = new javax.swing.JLabel();
        cmdCongestion = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        lblTitle.setText("Reception Stream. User : xxx, Meeting: xxx");

        lblBuffered.setText("0 sec buffered");

        lblScreen.setBackground(new java.awt.Color(0, 0, 0));
        lblScreen.setOpaque(true);

        cmdPlay.setEnabled(false);
        cmdPlay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdPlayActionPerformed(evt);
            }
        });

        cmdPause.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdPauseActionPerformed(evt);
            }
        });

        cmdFastFoward.setEnabled(false);
        cmdFastFoward.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdFastFowardActionPerformed(evt);
            }
        });

        cmdClose.setText("CLOSE");
        cmdClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdCloseActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        jLabel6.setText("Media type");

        cmbMediaType.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Audio and Video", "Audio only", "Video only", "None" }));
        cmbMediaType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbMediaTypeActionPerformed(evt);
            }
        });

        jLabel7.setText("Video frame rate");

        txtFrameRate.setText("1");

        jLabel8.setText("Frame/Sec");

        jLabel9.setText("Bandwidth auto control");

        cmdSet.setText("SET");
        cmdSet.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdSetActionPerformed(evt);
            }
        });

        chkAutoBW.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkAutoBWActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7)
                    .addComponent(jLabel9))
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(chkAutoBW))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(5, 5, 5)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(cmbMediaType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                .addComponent(txtFrameRate, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jLabel8)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(cmdSet)
                                .addGap(44, 44, 44)))))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(cmbMediaType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(jLabel8)
                    .addComponent(cmdSet)
                    .addComponent(txtFrameRate, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(chkAutoBW)
                    .addComponent(jLabel9))
                .addContainerGap())
        );

        cmdCongestion.setEnabled(false);
        cmdCongestion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdCongestionActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(lblTitle))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(lblScreen, javax.swing.GroupLayout.PREFERRED_SIZE, 320, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(cmdPlay)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(cmdPause)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(cmdFastFoward)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(lblCongestion)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(cmdCongestion)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(lblBuffered))))
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(cmdClose)
                                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 305, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 291, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblTitle)
                .addGap(8, 8, 8)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblScreen, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(cmdPlay)
                        .addComponent(cmdPause)
                        .addComponent(cmdFastFoward))
                    .addComponent(lblCongestion)
                    .addComponent(cmdCongestion)
                    .addComponent(lblBuffered))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 19, Short.MAX_VALUE)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cmdClose)
                .addGap(10, 10, 10))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        // TODO add your handling code here:
        lblTitle.setText("Reception Stream. User name: " + user + ", Meeting: " + meeting + "");
    }//GEN-LAST:event_formWindowOpened

    private void cmbMediaTypeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbMediaTypeActionPerformed
        // TODO add your handling code here:
        if (cmbMediaType.getSelectedIndex() == 0) {
            receivSound = true;
            receivVideo = true;
        } else if (cmbMediaType.getSelectedIndex() == 1) {
            receivSound = true;
            receivVideo = false;
        } else if (cmbMediaType.getSelectedIndex() == 2) {
            receivSound = false;
            receivVideo = true;
        } else {
            receivSound = false;
            receivVideo = false;
        }
    }//GEN-LAST:event_cmbMediaTypeActionPerformed

    private void cmdSetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdSetActionPerformed
        // TODO add your handling code here:
        try {
            double rate = Double.parseDouble(txtFrameRate.getText());
            if (rate == 0) {
                throw new Exception();
            }
            IMAGE_DURATION = (long) Math.round((1 / rate) * 1000);
            JOptionPane.showMessageDialog(this, "Video frame rate updated !");
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, "Please enter a number > 0");
        }
    }//GEN-LAST:event_cmdSetActionPerformed

    private void cmdPauseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdPauseActionPerformed
        // TODO add your handling code here:
        savedTime = System.nanoTime();
        pause = true;
        cmdPause.setEnabled(false);
        cmdPlay.setEnabled(true);
        cmdFastFoward.setEnabled(false);

    }//GEN-LAST:event_cmdPauseActionPerformed

    private void cmdPlayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdPlayActionPerformed
        // TODO add your handling code here:
        pause = false;

        cmdPause.setEnabled(true);
        cmdPlay.setEnabled(false);
        cmdFastFoward.setEnabled(true);
    }//GEN-LAST:event_cmdPlayActionPerformed

    private void cmdFastFowardActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdFastFowardActionPerformed
        // TODO add your handling code here:
        bufferedTime = 0;
        pause = false;

        cmdPause.setEnabled(true);
        cmdPlay.setEnabled(false);
        cmdFastFoward.setEnabled(false);

        lblBuffered.setText("0 sec buffered");
        soundQueue.clear();
    }//GEN-LAST:event_cmdFastFowardActionPerformed

    private void chkAutoBWActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkAutoBWActionPerformed
        // TODO add your handling code here:
        if (chkAutoBW.isSelected()) {
            txtFrameRate.setEnabled(false);
            cmbMediaType.setEnabled(false);
            cmdSet.setEnabled(false);
        } else {
            txtFrameRate.setEnabled(true);
            cmbMediaType.setEnabled(true);
            cmdSet.setEnabled(true);
        }
    }//GEN-LAST:event_chkAutoBWActionPerformed

    private void cmdCongestionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdCongestionActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_cmdCongestionActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        // TODO add your handling code here:
        this.receptionActive = false;
    }//GEN-LAST:event_formWindowClosing

    private void cmdCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdCloseActionPerformed
        // TODO add your handling code here:
        this.receptionActive = false;
        this.dispose();
    }//GEN-LAST:event_cmdCloseActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox chkAutoBW;
    private javax.swing.JComboBox cmbMediaType;
    private javax.swing.JButton cmdClose;
    private javax.swing.JButton cmdCongestion;
    private javax.swing.JButton cmdFastFoward;
    private javax.swing.JButton cmdPause;
    private javax.swing.JButton cmdPlay;
    private javax.swing.JButton cmdSet;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel lblBuffered;
    private javax.swing.JLabel lblCongestion;
    private javax.swing.JLabel lblScreen;
    private javax.swing.JLabel lblTitle;
    private javax.swing.JTextField txtFrameRate;
    // End of variables declaration//GEN-END:variables
    public javax.swing.JLabel screen = lblScreen;
}
