package audiovideo;


import java.awt.image.BufferedImage;
import java.net.*;
import java.io.*;
import javax.sound.sampled.*;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;

/**
 * @author user
 */
public class ServerAudio {

    static ServerSocket server;
    static ServerSocket serverVideo;
    static Socket client, clientVideo;
    static ArrayList<byte[]> audioBuffer = new ArrayList<byte[]>(10);
    static byte[] buffer;
    static int bufferSize;
//    static boolean gotFloor = true;
    static int numberClient = 0;
    static byte[] imageBuffer;

    public static void main(String[] argv) {
        try {
            // Server socket creation
            server = new ServerSocket(8081);
            serverVideo = new ServerSocket(8080);

            // Get the audio format
            final AudioFormat format = getFormat();

            // Create the buffer
            bufferSize = (int) (format.getSampleRate() * format.getFrameSize());
            buffer = new byte[bufferSize];

            // Starting the thread responsible for waiting video connection
            receivSendVideo();

            // Starting the thread responsible for waiting audio connection
            receivSendAudio();

        } catch (UnknownHostException ex) {
            Logger.getLogger(ServerAudio.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(ServerAudio.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    static private void receivSendAudio() throws IOException {
        while (true) {//Wait for client connection
            System.out.println("Waiting for client ...");
            client = server.accept();

            numberClient++;

            receivAudio();
            sendAudio();
        }
    }

    static private void receivSendVideo() {
        Runnable runnerReceivVideo = new Runnable() {

            OutputStream out;
            InputStream in;

            public void run() {
                while (true) {
                    try {
                        // Waiting for Video Client
                        System.out.println("Waiting for video client connection ...");
                        clientVideo = serverVideo.accept();
                        System.out.println("Video client connected");

                        // RECEIVE VIDEO
                        receivVideo();

                        // SEND VIDEO
                        sendVideo();

                    } catch (IOException ex) {
                        Logger.getLogger(ServerAudio.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
            }
        };

        Thread videoThread = new Thread(runnerReceivVideo);
        videoThread.start();

    }

    static private void receivVideo() throws IOException {

//        ObjectOutputStream outVideo = new ObjectOutputStream(clientVideo.getOutputStream());
        Runnable runner = new Runnable() {

            ObjectInputStream inVideo;

            public void run() {// RECEPTION OF IMAGES
                try {
                    inVideo = new ObjectInputStream(clientVideo.getInputStream());
                    while (true) {
                        //image = ImageIO.read(clientVideo.getInputStream());
//                                        image = (BufferedImage) inVideo.readObject();
                        imageBuffer = (byte[]) inVideo.readObject();
                        System.out.println("Image received, packet size:" + imageBuffer.length);

//                        byte bufNum[] = new byte[5];
//                        bufNum = intToByteArray(imageBuffer.length);
//                        
//                        System.out.println("After Conversion : "+ byteArrayToInt(bufNum));

                        Thread.sleep(Framework.IMAGE_DURATION);
                    }
                } catch (IOException ex) {
                    Logger.getLogger(ServerAudio.class.getName()).log(Level.SEVERE, null, ex);
                } catch (ClassNotFoundException ex) {
                    Logger.getLogger(ServerAudio.class.getName()).log(Level.SEVERE, null, ex);
                } catch (InterruptedException ex) {
                    Logger.getLogger(ServerAudio.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        };

        if (numberClient == 1) {
            Thread thread = new Thread(runner);
            thread.start();
        }
    }

    static private void sendVideo() throws IOException {
        Runnable runnerSend = new Runnable() {

//            ObjectOutputStream outVideo;
            ObjectOutputStream outVideo = new ObjectOutputStream(clientVideo.getOutputStream());

            public void run() {// TRANSMISSION OF IMAGES

                System.out.println("Sending images start");
//                    outVideo = new ObjectOutputStream(clientVideo.getOutputStream());
//                    outVideo = clientVideo.getOutputStream();
                while (true) {
                    try {
//                        outVideo.writeInt(imageBuffer.length);
                        //outVideo.write(intToByteArray(imageBuffer.length));
                        //System.out.println("Here what I wrote on the stream: "+ byteArrayToInt(intToByteArray(imageBuffer.length)));
//                        outVideo.write(imageBuffer);

                        ByteArrayInputStream bais = new ByteArrayInputStream(imageBuffer, 0, imageBuffer.length);
                        BufferedImage theBufImg = ImageIO.read(bais);
                        ByteArrayOutputStream baos = new ByteArrayOutputStream();
                        ImageIO.write(theBufImg, "JPEG", baos);
                        byte[] buf = baos.toByteArray();

                        //
//                        String test = "Yalala";
                        outVideo.writeObject(buf); //buf
                        Thread.sleep(Framework.IMAGE_DURATION);
                        System.out.println("Image sent, packet size:" + buf.length);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(ServerAudio.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (IOException ex) {
                        Logger.getLogger(ServerAudio.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }

            }
        };

        if (numberClient > 1) {
            Thread threadSend = new Thread(runnerSend);
            threadSend.start();
        }
    }

    static private void receivAudio() {
        Runnable runner = new Runnable() {

            OutputStream out;
            InputStream in;
            boolean quit = false;

            public void run() {
                try {
                    // get streams from the client
                    in = client.getInputStream();

                    int i = 1;

//                    if (gotFloor) {

                    while (!quit) {

                        // Reading the packet from the input stream
                        in.read(buffer);
                        if (in.available() != 0) {
                            System.out.println("Audio " + (i++) + " received " + buffer[0] + buffer[1] + buffer[2] + buffer[3]);
                        }
                    }
//                    }
                } catch (Exception ex) {
                    //ex.printStackTrace();
                    //Logger.getLogger(ServerAudio.class.getName()).log(Level.SEVERE, null, ex);
                    System.out.println("Bye bye client ...");
                    quit = true;
                }
            }
        };

        Thread captureThread = new Thread(runner);
        captureThread.start();
    }

    static private void sendAudio() {
        Runnable runnerBrod = new Runnable() {

            OutputStream out;
            InputStream in;
            boolean quit = false;

            public void run() {
                try {
                    System.out.println("Number of client " + numberClient);
                    if (numberClient > 1) {
                        // get streams from the client
                        out = client.getOutputStream();
                        int seq = 1; // default first seq number

                        System.out.println("Output read for sending. Buffer size " + buffer.length);

                        byte[] localBuffer = new byte[bufferSize];


                        while (!quit) {

                            if (!Arrays.equals(localBuffer, buffer)) {
                                System.out.println("The loop");
                                out.write(buffer);
                                System.arraycopy(buffer, 0, localBuffer, 0, buffer.length);
                                System.out.println("Audio " + seq++ + " sent");
                            }
                        }
                    }
                } catch (IOException ex) {
//                    Logger.getLogger(ServerAudio.class.getName()).log(Level.SEVERE, null, ex);
                    System.out.println("End of sending audio packets");
                    quit = true;
                }
            }
        };

        Thread captureThreadBroad = new Thread(runnerBrod);
        captureThreadBroad.start();
    }

    static private AudioFormat getFormat() {
        float sampleRate = 8000;
        int sampleSizeInBits = 8;
        int channels = 1;
        boolean signed = true;
        boolean bigEndian = true;
        return new AudioFormat(sampleRate,
                sampleSizeInBits, channels, signed, bigEndian);
    }

    public static byte[] intToByteArray(int value) {
        String number = "" + value;
        byte[] byteNumber = new byte[5];

        int digit = 0;
        for (int i = 0; i < 5; i++) {
            byteNumber[i] = (byte) digit;
        }

        for (int i = 0; i < number.length(); i++) {
            digit = Integer.parseInt("" + number.charAt(i));
            byteNumber[5 - number.length() + i] = (byte) digit;
        }

        return byteNumber;

//        byte[] b = new byte[4];
//        for (int i = 0; i < 4; i++) {
//            int offset = (b.length - 1 - i) * 8;
//            b[i] = (byte) ((value >>> offset) & 0xFF);
//        }
//        return b;
    }

    static private int byteArrayToInt(byte[] b) {
        String number = "";
        for (int i = 0; i < 5; i++) {
            number += b[i];
        }

        System.out.println("The number is : " + number);

        return Integer.parseInt(number);
    }
}
