
import java.io.*;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.http.*;
import javax.servlet.*;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

public class MultimediaServlet extends HttpServlet {

    @Override
    public void doGet(HttpServletRequest req, HttpServletResponse res) {
        doPost(req, res);
    }

    @Override
    public void doPost(HttpServletRequest req, HttpServletResponse res) {

        // Parameters
        String direction = req.getParameter("direction");
        String meeting = req.getParameter("meeting");
        String source = req.getParameter("source");

        if (direction.equals("floor")) {
            whoIsHoldingFloor(res, meeting);
            return;
        }

        String type = req.getParameter("type");
        String user = req.getParameter("user");
        String packetNumber = req.getParameter("packetnumber");

        String packetSize = req.getParameter("size");
        int size = 0;
        if (packetSize != null) {
            size = Integer.parseInt(packetSize);
        }

        // Log the parameters
        debug("doPost started. Direction = " + direction + "; Type = " + type +
                " ; User = " + user + " ; Meeting = " + meeting);

        if (direction.equals("upload")) {
            receivPacket(req, type, source, meeting, size, packetNumber, req.getRemoteAddr());
        } else {
            sendPackets(res, type, source, meeting, req.getRemoteAddr());
        }
    }

    private void sendPackets(HttpServletResponse res, String type, String user, String meeting, String ipAddress) {
        res.setContentType("image/gif");
        byte[] packetBuffer = new byte[1];
        byte[] globalVar;
        if (user.equals("__floor__")) {
            user = (String) this.getServletConfig().getServletContext().getAttribute("floor" + meeting);
        }

        globalVar = (byte[]) this.getServletConfig().getServletContext().getAttribute(type + user + meeting);
        String packetNumber = (String) this.getServletConfig().getServletContext().getAttribute(type + user + meeting + "packetnumber");

        try {
            OutputStream out = res.getOutputStream();
            ObjectOutputStream os = new ObjectOutputStream(out);
            if (globalVar != null) {
                ArrayList pack = new ArrayList();
                pack.add(globalVar);
                pack.add(packetNumber);
                os.writeObject(pack);
                os.flush();
                debug("Packet written, size = " + globalVar.length);
                log("out", type, user, globalVar.length, ipAddress);
            }
        } catch (Exception e) {
            debug(getStackTrace(e));
        }
    }

    private void whoIsHoldingFloor(HttpServletResponse res, String meeting) {
        res.setContentType("image/gif");
        String user = (String) this.getServletConfig().getServletContext().getAttribute("floor" + meeting);
        try {
            OutputStream out = res.getOutputStream();
            ObjectOutputStream os = new ObjectOutputStream(out);
            os.writeObject(user);
            os.flush();
            debug("The user holding the floor is " + user);
        } catch (Exception e) {
            debug(getStackTrace(e));
        }
    }

    private void receivPacket(HttpServletRequest req, String type, String user, String meeting, int size, String packetNumber, String ipAddress) {
        try {
            List<FileItem> items = new ServletFileUpload(new DiskFileItemFactory()).parseRequest(req);
            for (FileItem item : items) {
                if (!item.isFormField()) {
                    InputStream in = item.getInputStream();
                    byte[] packet = new byte[size];
                    in.read(packet, 0, size);
                    debug("Packet received, size = " + packet.length + " bytes");
                    log("in", type, user, packet.length, ipAddress);

                    this.getServletConfig().getServletContext().setAttribute(type + user + meeting, packet);
                    this.getServletConfig().getServletContext().setAttribute(type + user + meeting + "packetnumber", packetNumber);

                    // CODE TO BE REMOVED : THIS TASK WILL BE DONE BY FLORA'S CODE
                    this.getServletConfig().getServletContext().setAttribute("floor" + meeting, user);
                }
            }
        } catch (Exception e) {
            debug(getStackTrace(e));
        }
    }

    private void soundReceiver(HttpServletRequest req) throws IOException {
        debug("I m in SoundReceiver method");
        InputStream in = req.getInputStream();
        debug("I got the input stream");
        byte[] buf = new byte[1000];
        byte i = 0;

        try {
            while (true) {
                debug("I m in the loop, waiting for something to read ...");
                in.read(buf, 0, 1000);
                debug("Packet received, " + buf[0]);
            //buf[0] = i++;
            //this.getServletConfig().getServletContext().setAttribute("soundPacket", buf);

//                buf = new byte[1000];
//                serialize("sound.obj", buf);
//                break;
//                SoundReceiver.buffer = buf;

            }
        } catch (Exception ex) {
            debug(getStackTrace(ex));
        }
    }

    private void soundSender(HttpServletResponse res) throws IOException {
        byte[] buf;
        buf = new byte[1000];
        res.setContentType("image/gif");// application/octet-stream
        OutputStream out = res.getOutputStream();
        try {
            for (int i = 0; i < 500; i++) {

//                buf = SoundReceiver.buffer;
//                buf = (byte[]) deserialize("sound.obj");
//                buf = (byte[]) this.getServletConfig().getServletContext().getAttribute("soundPacket");
                buf[0] = (byte) i;
                out.write(buf, 0, 1000);
                out.flush();
                Thread.sleep(1000);

            }
        } catch (Exception ex) {
            debug(getStackTrace(ex));
        }
    }

    private void debug(String message) {
        BufferedWriter out = null;
        try {
            File file = new File("debug.txt");
            out = new BufferedWriter(new FileWriter(file, true));
            Calendar cal = Calendar.getInstance();
            SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
            out.write("\r\n" + sdf.format(cal.getTime()) + " " + message + "\r\n");

        } catch (Exception ex) {
            Logger.getLogger(MultimediaServlet.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                out.close();
            } catch (IOException ex) {
                Logger.getLogger(MultimediaServlet.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

    }

    private void log(String direction, String type, String user, int size, String ipAddress) {
        BufferedWriter out = null;
        try {
            File file = new File("log.csv");
            out = new BufferedWriter(new FileWriter(file, true));
            Calendar cal = Calendar.getInstance();
            SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
            out.write(sdf.format(cal.getTime()) + ";" + ipAddress + ";" + direction + ";" + type + ";" + user + ";" + size + "\r\n");

        } catch (Exception ex) {
            Logger.getLogger(MultimediaServlet.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                out.close();
            } catch (IOException ex) {
                Logger.getLogger(MultimediaServlet.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public static String getStackTrace(Throwable throwable) {
        Writer writer = new StringWriter();
        PrintWriter printWriter = new PrintWriter(writer);
        throwable.printStackTrace(printWriter);
        return writer.toString();
    }
}
